#
# $Id: uiGlobals.pm.in,v 1.25 2002/03/21 19:43:36 mcooper Exp $
#
# GLobals for user interface
#

package uiGlobals;

require 5.003;
require Exporter;

#
# Global variables
#
$Title				= 'MagniComp SysInfo';
$UIversion			= '$Revision: 1.25 $'; # '
$BinProgramName			= 'sysinfo';
$PrefsFile			= $ENV{'HOME'} . '/.sysinforc';
$PathSep			= '&';
$Debug;
$HelpTips;
$HelpTipsBackground		= '#FFFF99';
$MainWindow 			= undef;
$DataTabs 			= undef;
$PropertiesButton;
$InFile;
$SysInfo;
$SysInfoPath;
$MainGeometry			= '450x500';	# MainWindow geometry
$WidthChars			= 60;
$SplashLogo			= 'sysinfo-logo-image-large';
$SysInfoLogo18			= 'sysinfo-logo-image-18';
$SysInfoIcon			= 'sysinfo-icon-36x36';
$MagniCompLogo300		= 'magnicomp-logo-large';
$MyHostName;
$StatusMessage;			# Obsoleted by Balloon $HelpTips
$AfterID;
$IconDivider;
$OpenInputWin;

#
# Header definetions for $FT_COLUMNS
#
my @HardwareHeaders = (
			   { Name=>'ICON', 	Type=>'image' },
			   { Name=>'DEVICE', 	Type=>'text' },
			   { Name=>'VENDOR', 	Type=>'text' },
			   { Name=>'MODEL', 	Type=>'text' },
			   { Name=>'TYPE', 	Type=>'text' },
			   { Name=>'CLASS', 	Type=>'text' },
			   { Name=>'SPEED', 	Type=>'text' },
			   { Name=>'CAPACITY',	Type=>'text' },
		      );

my @PartHeaders = (
			   { Name=>'DEVICE', 	Type=>'text' },
			   { Name=>'CAPACITY',	Type=>'text' },
			   { Name=>'USED', 	Type=>'text' },
			   { Name=>'TYPE', 	Type=>'text' },
			   { Name=>'USAGE', 	Type=>'text' },
		      );

my @PrinterHeaders = (
			   { Name=>'ICON', 	Type=>'image' },
			   { Name=>'NAME', 	Type=>'text' },
			   { Name=>'ALIASES', 	Type=>'text' },
			   { Name=>'SERVER', 	Type=>'text' },
			   { Name=>'LANGUAGES', 	Type=>'text' },
			   { Name=>'DESCRIPTION', 	Type=>'text' },
		      );

my @SoftwareHeaders = (
			   { Name=>'NAME', 	Type=>'text' },
			   { Name=>'VERSION', 	Type=>'text' },
			   { Name=>'REV', 	Type=>'text' },
			   { Name=>'SIZE', 	Type=>'text' },
			   { Name=>'DESCRIPTION',Type=>'text' },
		      );

my @GenericHeaders  = (
			   { Name=>'DESCRIPTION',	Type=>'text' },
			   { Name=>'VALUE',		Type=>'text' },
		      );

my @KeyValDescHeaders  = (
			   { Name=>'DESCRIPTION',	Type=>'text' },
			   { Name=>'KEY',		Type=>'text' },
			   { Name=>'VALUE',		Type=>'text' },
		      );

#
# Class Name Variables
#
$CL_GENERAL	= 'General';
$CL_HARDWARE	= 'Hardware';
$CL_PARTITION	= 'Partition';
$CL_PRINTER	= 'Printer';
$CL_SOFTWARE	= 'Software';
$CL_KERNEL	= 'Kernel';
$CL_SYSCONF	= 'SysConf';

#
# Canonical list of all Classes
#
$Classes = [
	       {Name=>$CL_GENERAL,
	       	Show=>1,			# Show this by default?
		ExpandableItems=>0,		# Have expandable sub items?
		SlowRetrieve=>0,		# Probe/retrieve is slow?
		Headers=>\@GenericHeaders,
	        Desc=>'General system configuration'},
	       {Name=>$CL_HARDWARE,
	       	Show=>0,
		ExpandableItems=>1,
		Headers=>\@HardwareHeaders,
		Desc=>'Installed hardware devices'},
	       {Name=>$CL_PARTITION,
	       	Show=>0,
		ExpandableItems=>1,
		Headers=>\@PartHeaders,
		Desc=>'Disk partitions'},
	       {Name=>$CL_PRINTER,
	       	Show=>0,
		ExpandableItems=>1,
		Headers=>\@PrinterHeaders,
		Desc=>'Printer Queues'},
	       {Name=>$CL_SOFTWARE,
	       	Show=>0,
		ExpandableItems=>1,
		SlowRetrieve=>1,
		Headers=>\@SoftwareHeaders,
		Desc=>'Installed software'},
	       {Name=>$CL_KERNEL,
	       	Show=>0,
		ExpandableItems=>0,
		Headers=>\@GenericHeaders,
		Desc=>'Kernel configuration'},
	       {Name=>$CL_SYSCONF,
	       	Show=>0,
		ExpandableItems=>0,
		Headers=>\@KeyValDescHeaders,
		Desc=>'System configuration'},
	       ];

#
# Format Values (only the ones we care about in the GUI)
#
$FT_TREE	= 'tree';
$FT_COLUMNS	= 'columns';
$FW_TREE	= 'Tree';	# Should be the official widget names
$FW_COLUMNS	= 'HList';	# Should be the official widget names
$FormatTable = {
	$FT_TREE => 	{ Order=>0, Name=>$FT_TREE, 	
			  Icon=>'tree', 
			  Widget=>$FW_TREE,
			  Desc=>'Hierarchical Tree', },
	$FT_COLUMNS => 	{ Order=>1, Name=>$FT_COLUMNS,
		 	  Icon=>'columns',
			  Widget=>$FW_COLUMNS,
			  Desc=>'Fixed columns and rows' },
};
$FormatSelected = $FT_TREE;	# Indicate which format is currently selected

#
# Arrangement values
#
$AR_CONNECT			= 'Connection';
$AR_TYPE			= 'Type';
$ArrangeTable = {
	$AR_CONNECT => {
		Order=>0,			# Order to list in
		Name=>$AR_CONNECT,		# Canonical name
		Classes=>[ $CL_HARDWARE ],	# What classes this applies to?
		Icon=>'domino16',		# Icon to use
	},
	$AR_TYPE => {
		Order=>1,
		Name=>$AR_TYPE,
		Classes=>[ $CL_HARDWARE ],
		Icon=>'domino15',
	},
};
$ArrangeDefault = $AR_CONNECT;			# Default

#
# Fonts
#
$Font				= 'arial 12';
$FontMenuTitle			= $Font . ' bold';
$FontMenuItem			= $Font;
$FontTab			= $Font . ' bold';
$FontError			= $Font . ' bold';
$FontHdr			= $Font;
$FontLabel			= $Font;
$FontButton			= $Font;
$FontEntry			= $Font;
$FontTree			= 'fixed 12 normal'; # Must be a fixed width
$FontText			= $FontTree;

#
# Property States
#
$PS_OPEN			= 'open';
$PS_CLOSE			= 'close';

#
# @*@ are filled in by configure
# The tests are done to allow these variables to be set in 
# environment of the caller.
#
# NOTE: These variables match what's in "setup"
#
$prefix 			= $ENV{'prefix'};
$cfdir 				= $ENV{'cfdir'};
$exec_prefix 			= $ENV{'exec_prefix'};
$DefaultLibExecDir 		= $ENV{'DEFAULT_LIBEXECDIR'};
$LibExecDir			= $ENV{'SYSINFOLIBEXECDIR'};
if (!length($prefix)) {
    $prefix='/usr/local/lib/sysinfo';
}
if (!length($cfdir)) {
    $cfdir='/usr/local/lib/sysinfo/config';
}
if (!length($exec_prefix)) {
    $exec_prefix='/usr/local/lib/sysinfo';
}
if (!length($DefaultLibExecDir)) {
    $DefaultLibExecDir='/usr/local/lib/sysinfo/libexec';
}
if (!length($LibExecDir)) {
    $LibExecDir = $DefaultLibExecDir;
}
$LicenseTermsFile = $prefix . "/LICENSE.txt";

#
# Export variables
#
BEGIN {
    #
    # Export function
    #
    @ISA      = qw(Exporter);

    #
    # Variables and functions being auto exported
    #
    @EXPORT   = qw(
		   $Title $UIversion $BinProgramName
		   $PathSep
		   $PrefsFile $InFile $SysInfo $SysInfoPath
		   $MainWindow $DataTabs
		   $HelpTips $HelpTipsBackground
		   $MainGeometry $WidthChars $MyHostName $StatusMessage
		   $AfterID $IconDivider $OpenInputWin
		   $prefix $cfdir $exec_prefix
		   $DefaultLibExecDir $LibExecDir
		   $SplashLogo $SysInfoIcon $SysInfoLogo18 $MagniCompLogo300
		   $LicenseTermsFile
		   $Debug $PropertiesButton
		   $FormatTable $FormatSelected
		   $FT_TREE $FT_COLUMNS
		   $FW_TREE $FW_COLUMNS
		   $PS_OPEN $PS_CLOSE
		   $Font
		   $FontMenuTitle
		   $FontMenuItem
		   $FontTab $FontHdr
		   $FontLabel
		   $FontButton
		   $FontEntry
		   $FontError
		   $FontTree
		   $FontText
		   $Classes
		   $CL_GENERAL $CL_HARDWARE $CL_PARTITION $CL_SOFTWARE
		   $CL_PRINTER
		   $CL_KERNEL $CL_SYSCONF
		   $ArrangeTable $ArrangeDefault
		   $AR_CONNECT $AR_TYPE
		  );
}

1;
